import classes
import movescripts
import weapons
import gfx
from ika import *

REPUT = [
"Crime Lord",
"Criminal",
"Criminal",
"Criminal",
"Suspicios",
"Neutral",
"Helpful",
"Good",
"Good",
"Good",
"Lawful"
]
SKILLS = [
"Disaster",
"Very bad",
"Bad",
"Very clumsy",
"Clumsy",
"Average",
"Good",
"Very good",
"Skilled",
"Very skilled",
"Master",
]

info = {}
missions = {}
SHIFT = 50
class gameData:
	# This is the class for storing how much the player has gained.
	# A game should be able to be saved and loaded just using this class!
	def __init__( self, name ):
		self.name = name
		self.cash = 0
		#Reputation: bad 0 to 10 good
		self.reputation = 5
		self.skillsreputation = 5
		self.planet = 'sidunia'
		self.inventory = ['']
		self.fighter = classes.Fighter("fighter.png")
		self.fighter.weapons[0] = 'blaster'
		self.fighter.gadgets[0] = 'collector'
		self.fighters = [self.fighter]
		self.completedmissions = []
		
	def remove( self, slot ):
		if slot < len(self.fighter.weapons):
			if self.fighter.weapons[slot] == '':
				return
			self.inventory.insert( len(self.inventory)-1, self.fighter.weapons[slot] )
			self.fighter.weapons[slot] = ''
		else:
			slot -= len(self.fighter.weapons)
			if self.fighter.gadgets[slot] == '':
				return
			self.inventory.insert( len(self.inventory)-1, self.fighter.gadgets[slot] )
			self.fighter.gadgets[slot] = ''
			
	def equipweapon( self, wslot, islot ):
		if self.fighter.weapons[wslot] == '':
			self.fighter.weapons[wslot] = self.inventory.pop(islot)
		else:
			self.fighter.weapons[wslot], self.inventory[islot] = self.inventory[islot], self.fighter.weapons[wslot]
			
	def equipgadget( self, wslot, islot ):
		if self.fighter.gadgets[wslot] == '':
			self.fighter.gadgets[wslot] = self.inventory.pop(islot)
		else:
			self.fighter.gadgets[wslot], self.inventory[islot] = self.inventory[islot], self.fighter.gadgets[wslot]
			
	def save( self ):
		saveinfo = []
		saveinfo.append( `(self.name,self.cash,self.reputation,self.skillsreputation,self.planet)` )
		saveinfo.append( `self.inventory` )
		saveinfo.append( `self.completedmissions` )
		for f in self.fighters:
			saveinfo.append( `(f.imgfile,f.weapons[0],f.weapons[1],f.gadgets[0],f.gadgets[1],f.armorclass,f.shieldclass,f.genlvl)` )
		fp = open( "./saves/"+self.name+".sav","w" )
		for saveline in saveinfo:
			for char in saveline:
				fp.write( chr((ord(char)+SHIFT)%256) )
			fp.write("\n")
		fp.close()
		fp = open( "./saves/savefiles.dat","r+" )
		lines = fp.readlines()
		if lines.count(self.name+"\n") == 0:
			fp.write( self.name+"\n" )
		fp.close()
		
	def load( self ):
		fp = open( "./saves/"+self.name+".sav","r" )
		loadinfo = []
		lines = fp.readlines()
		for line in lines:
			line = line.strip()
			info = ""
			for char in line:
				info += chr((ord(char)-SHIFT)%256)
			loadinfo.append( info )
		fp.close()
		exec( "(self.name,self.cash,self.reputation,self.skillsreputation,self.planet)="+loadinfo[0] )
		self.inventory = eval( loadinfo[1] )
		self.completedmissions = eval( loadinfo[2] )
		self.fighters = []
		for i in range(3,len(loadinfo)):
			exec( "getinfo = "+loadinfo[i] )
			f = classes.Fighter( getinfo[0] )
			(f.imgfile,f.weapons[0],f.weapons[1],f.gadgets[0],f.gadgets[1],f.armorclass,f.shieldclass,f.genlvl) = getinfo
			self.fighters.append( f )
		self.fighter = self.fighters[0]


def missionsreevaluate( playerdata ):
	planetdata = info[playerdata.planet]
	amissions = []
	for mission in planetdata.missions:
		mdata = missions[ mission ]
		if (mdata.limit == 0 or mdata.limit > playerdata.completedmissions.count( mission )) and \
		(mdata.missionneeded == None or playerdata.completedmissions.count( mdata.missionneeded ) >= 1) and \
		(mdata.reputneeded == None or mdata.reputneeded[0] <= playerdata.reputation <= mdata.reputneeded[1]) and \
		(mdata.skillsneeded == None or mdata.skillsneeded <= playerdata.skillsreputation):
			if not mdata.special:
				amissions.append( mission )
			else:
				amissions = [ mission ]
				break
	return amissions


def initData():
	######### Planets ##########
	info['sidunia'] = classes.Planet("Sidunia Planet","sidunia.png","planet1.png",['mining','watering','chasepirates','pirateattack','piratelair'],['blaster','wassern','rocket','shield1'],2,['tardunia'])
	info['tardunia'] = classes.Planet("Tardunia Trading Planet","tardunia.png","planet2.png",['termination','termination2','termination3','chasepirates','protection'],['blaster','rocket','blaster2','scanner','shield1','shield2'],3,['merion'])
	info['merion'] = classes.Planet("Merion Planet","merion.png","planet3.png",[],[],3,[])

	######### Sideless sprites ##########
	info['explosion'] = classes.Object( None, classes.BOTH, 100, 100, classes.MEDIUM )
	info['meteoroid'] = classes.Object( "meteoroid.png", classes.BOTH, 1000,dmggiven=50,size=classes.LARGE,maxSpeed=1.7 )
	info['minimeteoroid'] = classes.Object( "minimeteoroid.png", classes.BOTH, 500, dmggiven=30, maxSpeed=2.7 )
	info['mineral'] = classes.Object( gfx.drawMineral, classes.BOTH, 300, w=10,h=10,maxSpeed=3.0,size=classes.COLLECTABLE )
	info['piratepiece'] = classes.Object( "piratepiece.png", classes.BOTH, 100, maxSpeed=3.0,size=classes.COLLECTABLE )
	info['dracenpiece'] = classes.Object( "dracenpiece.png", classes.BOTH, 100, maxSpeed=3.0,size=classes.COLLECTABLE )
	info['fielddry'] = classes.Object( "fields.png", classes.BOTH, 200, size=classes.VOID,obstructing=False )
	info['fieldwatered'] = classes.Object( "fields2.png", classes.BOTH, 200, size=classes.VOID,obstructing=False,freezable=False )
	info['trader'] = classes.Object( "trader.png", classes.BOTH, 3000, maxSpeed=1.5, size=classes.MEDIUM)
	info['trader2'] = classes.Object( "trader2.png", classes.BOTH, 300, maxSpeed=1.5, size=classes.MEDIUM)
	
	######### Sprites ##########
	info['pirate'] = classes.Object( "pirate.png", classes.ENEMY, 1000,maxSpeed=2.0,weapon='pirazer' ) 
	info['pirateboss'] = classes.Object( "pirateboss.png", classes.ENEMY, 30000,maxSpeed=1.0,size=classes.HUGE ) 
	info['dracen'] = classes.Object( "dracen.png", classes.ENEMY, 1000,maxSpeed=2.0,weapon='fireball' )
	info['dracbody'] = classes.Object( gfx.drawDracBody, classes.ENEMY, 1000000000,dmggiven=100,maxSpeed=2.0,w=40,h=40 ) 
	info['drachead'] = classes.Object( "dracen.png", classes.ENEMY, 30000,maxSpeed=2.0,weapon='fireball' )
	

	######### Weapons ##########
	info['blaster'] = classes.Weapon("blaster.png","Blaster","Your standard energy blaster. Level 1.",1,10,1000)
	info['blaster2'] = classes.Weapon("blaster2.png","Blaster2","Your standard energy blaster. Level 2.",2,10,2000)
	info['rocket'] = classes.Weapon("rocket.png","Rockets","Launches rockets for explosion damage. Level 1.",1,60,1500)
	info['wassern'] = classes.Weapon("wassern.png","Wassern","A watergun invented by German scientist Weinstein.",1,5,1000)
	info['pirazer'] = classes.Weapon("pirazer.png","Pirazer","A phaser gun used by pirates.",1,15,1500)
	info['firecannon'] = classes.Weapon("firecannon.png","Firecannon","Fire balls of fire.",2,30,2000)
	

	######### Gadgets ##########
	info['shield1'] = classes.Gadget("shield1.png","Shields1","Shield generator level 1, rebuilds your ships shields to shield your ship from\nenemy projectiles.\nAutoactivated. Rebuild factor: 1.",1,0,2000,True)
	info['shield2'] = classes.Gadget("shield2.png","Shields2","Shield generator level 2, rebuilds your ships shields to shield your ship from\nenemy projectiles.\nAutoactivated. Rebuild factor: 2.",2,0,4000,True)
	info['collector'] = classes.Gadget("collector.png","Collector","A \"magnet\" for attracting and picking up small objects, like minerals.",1,0,1000)
	info['scanner'] = classes.Gadget("scanner.png","Scanner","Scans and shows how much armor the target has left.\nAutoactivated.",1,200,1500,True)
	info['scanning'] = classes.Object( gfx.drawScanning, classes.BG, 1, maxSpeed=0 )
	info[''] = classes.Gadget("empty.png","Empty","This slot is empty.",0,0,0)
	

	######### Projectiles ##########
	info['blastershot'] = classes.Object("blaster.png",classes.PLAYER,1,100,classes.VOID,maxSpeed=100,projectile=True)
	info['rocketshot'] = classes.Object("rocket.png",classes.PLAYER,1,0,classes.SMALL,maxSpeed=100,projectile=True)
	info['wasserndrop'] = classes.Object(gfx.drawWassern,classes.PLAYER,1,10,classes.MEDIUM,statusgiven=classes.FREEZE,projectile=True)
	info['pirazershotplayer'] = classes.Object("pirazer.png",classes.PLAYER,1,150,classes.VOID,maxSpeed=100,projectile=True)
	info['fireballplayer'] = classes.Object(gfx.drawFire,classes.PLAYER,1000,50,classes.VOID,w=30,h=30,maxSpeed=10,statusgiven=classes.BURN,projectile=True)
	
	info['pirazershot'] = classes.Object("pirazer.png",classes.ENEMY,1,150,classes.VOID,maxSpeed=100,projectile=True)
	info['bulletshot'] = classes.Object(gfx.drawBullet,classes.ENEMY,1,100,classes.VOID,maxSpeed=10,w=15,h=15,projectile=True)
	info['fireball'] = classes.Object(gfx.drawFire,classes.ENEMY,1000,50,classes.VOID,w=30,h=30,maxSpeed=10,statusgiven=classes.BURN,projectile=True)
	
	######### Missions ##########
	missions['mining'] = classes.Mission("Minerals mining","Sidunia Planet has an astounding abundance of mineral-filled meteoroids\n"+
													       "orbitting around the planet. The selfsame meteoroids are also the reason this\n"+
													       "planet is so sparsely inhabitated... bigger spaceships have a hard time of\n"+
													       "landing, and the sun seldom shows for very large amount of time. Anyway, this\n"+
													       "mission is simple: Destroy meteoroids and pick up any mineral pieces left\n"+
													       "behind, using your collector. 100 cash for each mineral piece.")
	missions['chasepirates'] = classes.Mission("Chasing pirates","Miners have reported observations of pirates, who have been raiding miners\n"+
																 "for their gathered minerals. Please help us to destroy the pirates!\n"+
																 "200 cash for every pirate fighter you destroy.",
																 skillsneeded=7,reputneeded=[4,10],limit=3)
	missions['pirateattack'] = classes.Mission("Pirate attack!","It seems like pirates are planning on retaliation after you destroyed their\n"+
																   "comrades. A cluster of pirates have been reported gathering close to Sidunia,\n"+
																   "and they're heading towards us!\n"+
																   "You have to go out and meet them, our planetary defense system is not enough\n"+
																   "to defend against them!",
																   missionneeded='chasepirates',limit=1,special=True)
	missions['piratelair'] = classes.Mission("Pirate lair","The lair of the pirates have been discovered! Attack them, but be careful,\n"+
															"we're detecting a large warship in their lair. Make sure you're well\n"+
															"protected!\n"+
															"You'll get 5000 cash for destroying their warship, and 200 for each pirate\n"+
															"ship.",
															missionneeded='pirateattack',limit=1)
	missions['watering'] = classes.Mission("Water the fields","The reason that people can survive on this planet, even though the sun is mostly\n"+
															  "blocked out by the meteoroids, is the special wheat on this planet, which hardly\n"+
															  "requires the sun to grow. However, it needs a lot of water.\n"+
															  "Equip yourself with Wassern and make sure we'll have enough crops for another\n"+
															  "year! 100 cash for each field watered, -500 cash for each field destroyed.\n"+
															  "Overwatering will also destroy the fields!",
															  'SandField', weaponsneeded=['wassern'],reputneeded=[4,10])
	missions['termination'] = classes.Mission("Dracen termination","Recently the towns in Tardunia have been bothered by hordes of Dracens,\n"+
																   "firebreathing annoying little buggers. The traders aren't too happy about\n"+
																   " having their shops burned to ashes.\n"+
																   "You get 100 cash for each one you kill.\n",
																   bg = 'SandField')
	missions['termination2'] = classes.Mission("Dracen invasion!","A horde of Dracens have gotten into the town centre! Destroy as many of them\n"+
																   "as you can, but be careful with the traders!\n"+
																   "You get 150 cash for each one you kill, but you'll lose 500 cash for any\n"+
																   "traders you destroy.\n",
																   bg = 'SandField',limit=1,skillsneeded=9,special=True)
	missions['termination3'] = classes.Mission("Dracen lair","One of the Dracens lairs have been found near the city centre. We'll give you\n"+
															 "5000 cash for taking out their leader, plus 100 cash for each Dracen you\n"+
															 "destroy!",
															 bg = 'SandField',limit=3,missionneeded = 'termination2' )
	missions['protection'] = classes.Mission("Trader protection","Emcion, a rich trader from Merion, is looking for someone to protect him on the\n"+
																 "route from the city centre to the interplanetary cruiser. Make sure he isn't\n"+
																 "attacked by any Dracens. There may also be pirates who wants his cargo.\n"+
																 "5000 cash on arrival at target location.\n",
																 bg = 'SandField',reputneeded=[4,10],skillsneeded=8,limit=1)
