import classes
import data
import movescripts
import missions
from ika import *

screen = Video
fnt = Font("./graphics/if.fnt")
plainfnt = Font("./graphics/plain.fnt")
class MissionData:
	statchanges = (1,0,0,0,None)
	def __init__( self, missionname, bgsong ):
		self.missionname = missionname
		self.bgsong = bgsong
		self.bg = eval( "classes."+data.missions[missionname].bg+"()" )
		self.fighter = data.info[ 'fighter' ]
		self.fpart = classes.Particle('fighter',classes.PLAYER,spawnondeath=classes.Explosion(drawsize=150,lifetime=500))
		self.fpart.moveScript = movescripts.keyFighterMove
		self.fpart.attackScript = movescripts.keyFighterAttack
		self.fpart.x = Video.xres/2
		self.fpart.y = Video.yres+100
		self.fpart.ySpeed = -5
		self.sprites = [ self.fpart ]
		self.collected = []
		self.playerdestroyed = []
		self.destroyed = []
		self.notdestroyed = []

		self.infobarpic = Image("./graphics/info/infobar.png")
		self.armorpic = Image("./graphics/info/armor.png")
		self.fpart.armor = 1000*self.fighter.armorclass
		self.shieldpic = Image("./graphics/info/shield.png")
		self.fpart.shield = 0
		self.genslotpics = [Image("./graphics/info/unused.png"),
							Image("./graphics/info/blueuse.png"),
							Image("./graphics/info/greenuse.png"),
							Image("./graphics/info/reduse.png"),
							Image("./graphics/info/yellowuse.png")]
		
		self.gamestate = 'normal'
		self.fadecounter = 0
		self.done = False
	
	def run( self ):
		self.pretimer = GetTime()
		self.timer = -50
		if self.bgsong != None:
			self.bgsong.Play()
		while not self.done:
			while self.pretimer < GetTime():
				Input.Update()
				self.pretimer += 1
				if self.gamestate != 'paused':
					self.mainTimer( self.timer )
					self.timer += 1
			screen.DrawRect(0,0,screen.xres,screen.yres,RGB(0,0,0),1)
			self.mainRetrace()
			Video.ShowPage()
		if self.bgsong != None:
			self.bgsong.Pause()
		return self.statchanges
			
	
	def mainTimer( self, timer ):
		missions.missiontimer( self.missionname, self )
		for i in range(len(self.sprites)):
			if i<len(self.sprites):
				sprite = self.sprites[i]
				if timer % 5 == 0:
					sprite.checkHits( self, self.sprites[i+1:] )
				sprite.tick( self )
				sprite.moveScript(sprite,self)
				if sprite.status != classes.FREEZE:
					sprite.attackScript(sprite,self)
				i += 1
		self.bg.move(0,1)
		if self.timer < 0:
			self.fpart.y += self.fpart.ySpeed*2
			self.fpart.xSpeed = 0
			self.fpart.ySpeed += 0.01
		if self.fpart.armor <= 0 and self.gamestate != 'fadeout':
			self.gamestate = 'gameover'
			self.statchanges = (0,0,0,0,None)
		if self.gamestate == 'missioncompleted':
			if self.fpart.y > -100:
				self.fpart.y += self.fpart.ySpeed
				self.fpart.xSpeed = 0
				self.fpart.ySpeed -= 0.2
				self.fpart.yAcc = -1
		if self.gamestate == 'fadeout':
			self.fadecounter += 1
			if self.fadecounter == 50:
				self.done = True
		
			
	def mainRetrace( self ):	
		self.bg.draw()
		for sprite in self.sprites:
			sprite.blit()
		if self.fpart.armor > 0:
			self.fpart.blit()
		self.showStats()
		if self.gamestate == 'normal':
			if Input.enter.Pressed():
				self.gamestate = 'paused'
				if self.bgsong != None:
					self.bgsong.Pause()
			if Input['ESCAPE'].Pressed() and not data.missions[self.missionname].special:
				self.gamestate = 'fadeout'
				self.statchanges = (2,0,0,-1,None)
		if self.gamestate == 'gameover':
			fnt.CenterPrint(320,240,"Game over")
			if Input.enter.Pressed():
				self.gamestate = 'fadeout'
		if self.gamestate == 'missionfailed':
			fnt.CenterPrint(320,240,"Mission failed")
			if Input.enter.Pressed():
				self.gamestate = 'fadeout'
		if self.gamestate == 'missioncompleted':
			if self.fpart.y > -100:
				self.fpart.blit()
			missions.missionreport( self.missionname, self )
			if Input.enter.Pressed():
				self.gamestate = 'fadeout'
		if self.gamestate == 'paused':
			fnt.CenterPrint(320,230,"Pause")
			if Input.enter.Pressed():
				self.gamestate = 'normal'
				if self.bgsong != None:
					self.bgsong.Play()
		if self.timer < 0:
			Video.DrawRect(0,0,Video.xres,Video.yres,RGB(0,0,0,int(-self.timer*255/50)),1)
			fnt.CenterPrint(320,230,"Mission start!")
		if self.gamestate == 'fadeout':
			Video.DrawRect(0,0,Video.xres,Video.yres,RGB(0,0,0,int(self.fadecounter*240/50)),1)
				
		
	statsleft = 0
	statstop = 0
	def showStats( self ):
		STATSLEFT = self.statsleft
		STATSTOP = self.statstop
		self.infobarpic.Blit( STATSLEFT,STATSTOP )
		Video.ClipScreen( STATSLEFT+40, Video.yres-(STATSTOP+42), int(self.fpart.armor*59/(1000*self.fighter.armorclass)), Video.yres-(STATSTOP+61) )
		self.armorpic.Blit( STATSLEFT+40,STATSTOP+42)
		Video.ClipScreen( STATSLEFT+44, Video.yres-(STATSTOP+60), int(self.fpart.shield*52/(1000*self.fighter.shieldclass)), Video.yres-(STATSTOP+75) )
		self.shieldpic.Blit( STATSLEFT+44,STATSTOP+60)
		Video.ClipScreen()
		for i in range(self.fighter.genlvl):
			self.genslotpics[self.fpart.genused[i]].Blit(STATSLEFT+63+i*9,STATSTOP+75)
		data.info[self.fighter.weapons[0]].icon.Blit(STATSLEFT+30,STATSTOP+4)
		data.info[self.fighter.weapons[1]].icon.Blit(STATSLEFT+89,STATSTOP+5)
		data.info[self.fighter.gadgets[0]].icon.Blit(STATSLEFT+4,STATSTOP+60)
		data.info[self.fighter.gadgets[1]].icon.Blit(STATSLEFT+103,STATSTOP+50)
		#plainfnt.Print(300,0,`self.timer`)