from ika import *
import classes
import data
import flight
import title

fnt = Font("./graphics/if.fnt")
plainfnt = Font("./graphics/plain.fnt")
white100 = RGB(255,255,255,100)

def newgame( playername ):
	playerdata = data.gameData( playername )
	startgame( playerdata )

def loadgame( playername ):
	playerdata = data.gameData( playername )
	playerdata.load()
	startgame( playerdata )

def startgame( playerdata ):
	# Game data initializations!
	data.initData()
	planetdata = data.info[playerdata.planet]
	menusong = Sound("SUBSPACE.IT"); menusong.loop = 1; menusong.Play()
	#~ data.info['fighter'] = playerdata.fighter
	#~ nextmission = flight.MissionData( 'mining' )
	#~ nextmission.run()
	#~ Exit()
	
	songs = ['No music']
	fp = open( "./music/list", "r" )
	anysongs = fp.readlines()
	fp.close()
	if len(anysongs) == 0:
		selsong = 0
	else:
		selsong = 1
		songs.append( 'Random' )
		songs += anysongs
	del(anysongs)
	
	
	# Initializations of main screen graphics and variables
	selections = ["Start","Equip","Hangar","Shop","Travel","Save","Quit"]
	enabled = [1,1,1,1,0,0,1]
	SAVESLOT = 5
	sel = 0; sel2 = 0; sel3 = 0;
	state = 'mainscreen'
	availablemissions = data.missionsreevaluate( playerdata )
	upgradeprices = [playerdata.fighter.armorclass*5000,playerdata.fighter.shieldclass*5000,playerdata.fighter.genlvl*5000]
	if len(planetdata.travelto)>0 and playerdata.cash >= data.info[planetdata.travelto[0]].price:
		enabled[4] = 1

	buttonpic = Image("./graphics/mainscreen/button.png")
	offlightpic = Image("./graphics/mainscreen/offlight.png")
	onlightpic = Image("./graphics/mainscreen/onlight.png")
	sellightpic = Image("./graphics/mainscreen/sellight.png")


	# Main loop start!
	done = False
	pretimer = GetTime()
	timer = 0
	while not done:
		# Timing loop, in case we need it for something...
		while pretimer < GetTime():
			Input.Update()
			pretimer += 1
			timer += 1
			if timer == 50:
				Input.ClearKeyQueue()
			if state == 'fadeout':
				sel2 -= 1
				if sel2 == 1:
					done = True
			
		# The background of main screen!
		Video.DrawRect(0,0,Video.xres,Video.yres, RGB(0,0,0),1)
		planetdata.planetpic.Blit(0,0)
		planetdata.namepic.Blit(10,10)
		
		# Player statistics
		Video.DrawRect(5,60,220,330,RGB(0,0,0,150),1)
		Video.DrawRect(5,60,220,330,RGB(100,255,100))
		fnt.Print(20,70,playerdata.name)
		plainfnt.Print(20,100,"Cash: "+`playerdata.cash`)
		plainfnt.Print(20,115,"Reputation: "+data.REPUT[playerdata.reputation])
		plainfnt.Print(20,130,"Skills reputation: "+data.SKILLS[playerdata.skillsreputation])
		playerdata.fighter.img[2].Blit(20,170)
		plainfnt.Print(20,230,"Armor:\nClass "+`playerdata.fighter.armorclass`)
		plainfnt.Print(20,260,"Shield:\nClass "+`playerdata.fighter.shieldclass`)
		plainfnt.Print(20,290,"Generator:\nLevel "+`playerdata.fighter.genlvl`)
		i = 170
		for item in playerdata.fighter.weapons:
			Video.DrawEllipse( 117,i+16, 15,15, RGB(255,50,50,100),1 )
			data.info[item].icon.Blit(100,i)
			plainfnt.Print(140,i+10,data.info[item].name)
			i += 40
		for item in playerdata.fighter.gadgets:
			Video.DrawEllipse( 117,i+16, 15,15, RGB(50,255,50,100),1 )
			data.info[item].icon.Blit(100,i)
			plainfnt.Print(140,i+10,data.info[item].name)
			i += 40
		

		# Menu buttons
		for i in range(len(selections)):
			buttonpic.Blit(470,10+i*60)
			if enabled[i]:
				onlightpic.Blit(474,51+i*60)
			else:
				offlightpic.Blit(474,51+i*60)
			fnt.Print(500,25+i*60,selections[i])
		sellightpic.Blit(470,10+sel*60)
		
		# Background for upper-right box
		Video.DrawRect(220,60,450,330,RGB(0,0,0,150),1)
		Video.DrawRect(220,60,450,330,RGB(100,255,100))

		# Info about the selection in the menu
		# Moving in the menu
		if state == 'mainscreen' and timer > 50:
			if Input.up.Pressed():
				sel -= 1
			if Input.down.Pressed():
				sel += 1
			sel %= len(selections)
			invstart = 0
			if Input.enter.Pressed():
				sel2 = 0
				sel3 = 0
				if selections[sel] == "Start":
					state = 'missionselect'
				if selections[sel] == "Equip":
					state = 'equipping'
				if selections[sel] == "Hangar":
					state = 'hangar'
				if selections[sel] == "Shop" and len(planetdata.shopitems) > 0:
					state = 'shopping'
				if selections[sel] == "Save":
					enabled[SAVESLOT] = 1
					playerdata.save()
				if selections[sel] == "Travel" and len(planetdata.travelto) > 0:
					state = 'travelling'
				if selections[sel] == "Quit":
					state = 'quitconfirm'
			if Input['ESCAPE'].Pressed():
				sel2 = 0
				state = 'quitconfirm'
				
				
		# The part of the menu where you select missions
		if selections[sel] == "Start":
			fnt.Print(235,70,"Missions")
			i = 100
			for item in availablemissions:
				mdata = data.missions[item]
				plainfnt.Print(235,i,mdata.name)
				i += 15
		if state == 'missionselect':
			Video.DrawRect(5,330,450,470,RGB(0,0,0,150),1)
			Video.DrawRect(5,330,450,470,RGB(100,255,100))
			Video.DrawRect(234,99+sel2*15,364,113+sel2*15,RGB(255,255,255))
			data.missions[availablemissions[sel2]].showinfo()
			if Input.up.Pressed():
				sel2 -= 1
			if Input.down.Pressed():
				sel2 += 1
			sel2 %= len(availablemissions)
			if Input['ESCAPE'].Pressed():
				state = 'mainscreen'
			if Input.enter.Pressed():
				bgsong = None; menusong.Pause()
				if selsong > 1:
					bgsong = Sound( "./music/"+songs[selsong][:-1] )
				elif selsong == 1:
					bgsong = Sound( "./music/"+songs[Random(2,len(songs))][:-1] )
				data.info['fighter'] = playerdata.fighter
				nextmission = flight.MissionData( availablemissions[sel2], bgsong )
				alive, cash, reput, skills, itemgained = nextmission.run()
				playerdata.cash += cash
				playerdata.reputation += reput
				if playerdata.reputation < 0:
					playerdata.reputation = 0
				if playerdata.reputation > 10:
					playerdata.reputation = 10
				playerdata.skillsreputation += skills
				if playerdata.skillsreputation < 0:
					playerdata.skillsreputation = 0
				if playerdata.skillsreputation > 10:
					playerdata.skillsreputation = 10
				enabled[SAVESLOT] = 0
				if not alive:
					done = True
				elif alive == 1:
					if data.missions[availablemissions[sel2]].limit > 0:
						playerdata.completedmissions.append( availablemissions[sel2] )
					if itemgained != None:
						playerdata.inventory.insert( len(playerdata.inventory)-1, itemgained )
					if len(planetdata.travelto)>0 and playerdata.cash >= data.info[planetdata.travelto[0]].price:
						enabled[4] = 1
					state = 'mainscreen'
				else:
					state = 'mainscreen'
				del( bgsong )
				menusong.Play(); availablemissions = data.missionsreevaluate( playerdata )
				Input.up.Pressed()
				Input.down.Pressed()
		
		
		# The part of the menu where you equip
		if selections[sel] == "Equip":
			fnt.Print(235,70,"Inventory")
			i = 115
			for item in playerdata.inventory[invstart:invstart+5]:
				if item == '':
					color = RGB(50,50,255,100)
				elif isinstance( data.info[item], classes.Weapon ):
					color = RGB(255,50,50,100)
				else:
					color = RGB(50,255,50,100)
				Video.DrawEllipse( 235+16,i+16, 15,15,color ,1 )
				data.info[item].icon.Blit(235,i)
				plainfnt.Print(275,i+10,data.info[item].name)
				i += 40
			if len(playerdata.inventory)>5:
				if invstart+5 < len(playerdata.inventory):
					Video.DrawTriangle( (270,312,white100),(330,312,white100),(300,327,white100) )
				if invstart > 0:
					Video.DrawTriangle( (270,110,RGB(255,255,255,100)),(330,110,RGB(255,255,255,100)),(300,95,RGB(255,255,255,100)) )
		if state[:9] == 'equipping':
			Video.DrawRect(5,330,450,470,RGB(0,0,0,150),1)
			Video.DrawRect(5,330,450,470,RGB(100,255,100))
			Video.DrawRect(234,113+(sel2-invstart)*40,440,148+(sel2-invstart)*40,RGB(255,255,255))
			if state[9:] != "":
				if Input.up.Pressed():
					sel3 -= 1
				if Input.down.Pressed():
					sel3 += 1
				if Input['ESCAPE'].Pressed():
					state = 'equipping'
				if state[9:] == 'remove':
					sel3 %= len(playerdata.fighter.weapons+playerdata.fighter.gadgets)
					data.info[(playerdata.fighter.weapons+playerdata.fighter.gadgets)[sel3]].showinfo(plainfnt)
					Video.DrawRect(98,168+sel3*40,218,205+sel3*40,RGB(255,255,255))
					if Input.enter.Pressed():
						playerdata.remove( sel3 )
						state = 'equipping'
				if state[9:] == 'weapon':
					sel3 %= len(playerdata.fighter.weapons)
					data.info[playerdata.fighter.weapons[sel3]].showinfo(plainfnt)
					Video.DrawRect(98,168+sel3*40,218,205+sel3*40,RGB(255,255,255))
					if Input.enter.Pressed():
						playerdata.equipweapon( sel3, sel2 )
						state = 'equipping'
				elif state[9:] == 'gadget':
					sel3 %= len(playerdata.fighter.gadgets)
					data.info[playerdata.fighter.weapons[sel3]].showinfo(plainfnt)
					Video.DrawRect(98,248+sel3*40,218,285+sel3*40,RGB(255,255,255))
					if Input.enter.Pressed():
						playerdata.equipgadget( sel3, sel2 )
						state = 'equipping'
			else:
				data.info[playerdata.inventory[sel2]].showinfo(plainfnt)
				if Input.up.Pressed():
					sel2 -= 1
				if Input.down.Pressed():
					sel2 += 1
				if sel2 < 0:
					sel2 = 0
				if sel2 >= len(playerdata.inventory):
					sel2 = len(playerdata.inventory)-1
				if sel2-invstart>=5:
					invstart += 1
				if sel2<invstart:
					invstart -= 1
				if Input['ESCAPE'].Pressed():
					state = 'mainscreen'
				if Input.enter.Pressed():
					enabled[SAVESLOT] = 0
					sel3 = 0
					if playerdata.inventory[sel2] == '':
						state = 'equippingremove'
					elif isinstance( data.info[playerdata.inventory[sel2]], classes.Weapon ):
						state = 'equippingweapon'
					elif isinstance( data.info[playerdata.inventory[sel2]], classes.Gadget ):
						state = 'equippinggadget'
						
						
		# The place where you maintain the fighter
		if selections[sel] == "Hangar":
			fnt.Print(235,70,"Hangar")
			plainfnt.Print( 235, 100, "Select fighter" )
			plainfnt.Print( 235, 115, "Background music: "+songs[selsong][:17] )
			plainfnt.Print( 235, 130, "Upgrade armor" )
			if planetdata.upgrademax > playerdata.fighter.armorclass:
				plainfnt.RightPrint( 430, 130, `upgradeprices[0]` )
			plainfnt.Print( 235, 145, "Upgrade shield" )
			if planetdata.upgrademax > playerdata.fighter.shieldclass:
				plainfnt.RightPrint( 430, 145, `upgradeprices[1]` )
			plainfnt.Print( 235, 160, "Upgrade generator" )
			if planetdata.upgrademax > playerdata.fighter.genlvl:
				plainfnt.RightPrint( 430, 160, `upgradeprices[2]` )
		if state[:6] == 'hangar':
			Video.DrawRect(5,330,450,470,RGB(0,0,0,150),1)
			Video.DrawRect(5,330,450,470,RGB(100,255,100))
			if state == 'hangar':
				if sel2 == 2:
					if planetdata.upgrademax > playerdata.fighter.armorclass:
						plainfnt.Print( 10, 335, "Upgrade your armor to class "+`playerdata.fighter.armorclass+1`+"!" )
					else:
						plainfnt.Print( 10, 335, "This planet doesn't have technology to upgrade your armor past class "+`planetdata.upgrademax`+"." )
				if sel2 == 3:
					if planetdata.upgrademax > playerdata.fighter.shieldclass:
						plainfnt.Print( 10, 335, "Upgrade your shield to class "+`playerdata.fighter.shieldclass+1`+"!" )
					else:
						plainfnt.Print( 10, 335, "This planet doesn't have technology to upgrade your shield past class "+`planetdata.upgrademax`+"." )
				if sel2 == 4:
					if planetdata.upgrademax > playerdata.fighter.genlvl:
						plainfnt.Print( 10, 335, "Upgrade your energy generator to level "+`playerdata.fighter.genlvl+1`+"!" )
					else:
						plainfnt.Print( 10, 335, "This planet doesn't have technology to upgrade your generator past level "+`planetdata.upgrademax`+"." )
				if Input.up.Pressed():
					sel2 -= 1
				if Input.down.Pressed():
					sel2 += 1
				if Input['ESCAPE'].Pressed():
					state = 'mainscreen'
				sel2 %= 5
				if Input.enter.Pressed():
					enabled[SAVESLOT] = 0
					sel3 = 0
					if sel2 == 0:
						state = 'hangarfighter'
						sel3 = playerdata.fighters.index(playerdata.fighter)
					if sel2 == 1:
						state = 'hangarmusic'
						songstart = 0
					elif playerdata.cash > upgradeprices[sel2-2] and \
					(  (sel2==2 and planetdata.upgrademax>playerdata.fighter.armorclass) \
					or (sel2==3 and planetdata.upgrademax>playerdata.fighter.shieldclass) \
					or (sel2==4 and planetdata.upgrademax>playerdata.fighter.genlvl) ):
						state = 'hangarconfirm'
			Video.DrawRect(234,99+sel2*15,435,113+sel2*15,RGB(255,255,255))
			if state == 'hangarfighter':
				if Input.left.Pressed(): sel3 -= 1
				if Input.right.Pressed(): sel3 += 1
				sel3 %= len(playerdata.fighters)
				if Input.enter.Pressed():
					playerdata.fighter = playerdata.fighters[sel3]
					upgradeprices = [playerdata.fighter.armorclass*5000,playerdata.fighter.shieldclass*5000,playerdata.fighter.genlvl*5000]
					state = 'hangar'
				if Input['ESCAPE'].Pressed():
					state = 'hangar'
				thex = 15
				for fighter in playerdata.fighters:
					fighter.img[2].Blit(thex,335)
					if sel3 == playerdata.fighters.index(fighter):
						Video.DrawRect(thex-2,333,thex+fighter.w+2,337+fighter.h,RGB(255,255,255))
					thex += fighter.w + 10
			if state == 'hangarmusic':
				fnt.Print(235,190,"Songs")
				i = 220
				for song in songs[songstart:songstart+7]:
					plainfnt.Print( 235, i, song )
					i += 15
				if Input.up.Pressed():
					selsong -= 1
				if Input.down.Pressed():
					selsong += 1
				if selsong-6 > songstart:
					songstart = selsong - 6
				if selsong < songstart:
					songstart = selsong
				selsong %= len(songs)
				Video.DrawRect(234,219+(selsong-songstart)*15,435,233+(selsong-songstart)*15,RGB(255,255,255))
				if songstart>0:
					Video.DrawTriangle( (436,225,white100),(444,225,white100),(440,220,white100) )
				if songstart+7<len(songs):
					Video.DrawTriangle( (436,315,white100),(444,315,white100),(440,320,white100) )
				if Input['ESCAPE'].Pressed():
					state = 'hangar'
				if Input.enter.Pressed():
					state = 'hangar'
			if state == 'hangarconfirm':
				Video.DrawRect(180,200,460,300,RGB(0,0,0,200),1)
				Video.DrawRect(180,200,460,300,RGB(100,255,100))
				Video.DrawRect(295+sel3*30,248,322+sel3*30,263,RGB(255,255,255))
				if Input.right.Pressed():	sel3 = 1
				if Input.left.Pressed():	sel3 = 0
				plainfnt.CenterPrint( 320,210, "Do you want to upgrade your "+['armor','shield','generator'][sel2-2]+" for "+`upgradeprices[sel2-2]`+"?" )
				plainfnt.CenterPrint( 320,230, "You have "+`playerdata.cash`+" cash." )
				plainfnt.CenterPrint( 320,250, "Yes\tNo" )
				if Input['ESCAPE'].Pressed():
					state = 'hangar'
				if Input.enter.Pressed():
					state = 'hangar'
					if sel3 == 0:
						if sel2 == 2:
							playerdata.cash -= upgradeprices[0]
							playerdata.fighter.armorclass += 1
						if sel2 == 3:
							playerdata.cash -= upgradeprices[1]
							playerdata.fighter.shieldclass += 1
						if sel2 == 4:
							playerdata.cash -= upgradeprices[2]
							playerdata.fighter.genlvl += 1
						upgradeprices = [playerdata.fighter.armorclass*5000,playerdata.fighter.shieldclass*5000,playerdata.fighter.genlvl*5000]
						
						
		# The part of the menu where you can buy things
		if selections[sel] == "Shop":
			fnt.Print(235,70,"Shop")
			i = 115
			for item in planetdata.shopitems[invstart:invstart+5]:
				if item == '':
					color = RGB(50,50,255,100)
				elif isinstance( data.info[item], classes.Weapon ):
					color = RGB(255,50,50,100)
				else:
					color = RGB(50,255,50,100)
				Video.DrawEllipse( 235+16,i+16, 15,15,color ,1 )
				data.info[item].icon.Blit(235,i)
				plainfnt.Print(275,i+10,data.info[item].name)
				plainfnt.RightPrint(430,i+10,`data.info[item].price`)
				i += 40
			if len(planetdata.shopitems)>5:
				if invstart+5 < len(planetdata.shopitems):
					Video.DrawTriangle( (270,312,RGB(255,255,255,100)),(330,312,RGB(255,255,255,100)),(300,327,RGB(255,255,255,100)) )
				if invstart > 0:
					Video.DrawTriangle( (270,110,RGB(255,255,255,100)),(330,110,RGB(255,255,255,100)),(300,95,RGB(255,255,255,100)) )
		if state[:8] == 'shopping':
			item = data.info[planetdata.shopitems[sel2]]
			Video.DrawRect(5,330,450,470,RGB(0,0,0,150),1)
			Video.DrawRect(5,330,450,470,RGB(100,255,100))
			Video.DrawRect(234,113+(sel2-invstart)*40,440,148+(sel2-invstart)*40,RGB(255,255,255))
			item.showinfo( plainfnt )
			if state == 'shopping':
				if Input.up.Pressed():	sel2 -= 1
				if Input.down.Pressed():sel2 += 1
				if sel2 < 0:			sel2 = 0
				if sel2 >= len(planetdata.shopitems): sel2 = len(planetdata.shopitems)-1
				if sel2-invstart>=5:	invstart += 1
				if sel2<invstart:		invstart -= 1
				if Input['ESCAPE'].Pressed():	state = 'mainscreen'
				if Input.enter.Pressed() and item.price <= playerdata.cash:
					state = 'shoppingconfirm';
					sel3 = 0
			if state == 'shoppingconfirm':
				Video.DrawRect(180,200,460,300,RGB(0,0,0,200),1)
				Video.DrawRect(180,200,460,300,RGB(100,255,100))
				Video.DrawRect(295+sel3*30,248,322+sel3*30,263,RGB(255,255,255))
				if Input.right.Pressed():	sel3 = 1
				if Input.left.Pressed():	sel3 = 0
				plainfnt.CenterPrint( 320,210, "Do you want to buy "+item.name+" for "+`item.price`+"?" )
				plainfnt.CenterPrint( 320,230, "You have "+`playerdata.cash`+" cash." )
				plainfnt.CenterPrint( 320,250, "Yes\tNo" )
				if Input['ESCAPE'].Pressed():
					state = 'shopping'
				if Input.enter.Pressed():
					enabled[SAVESLOT] = 0
					state = 'shopping'
					if sel3 == 0:
						playerdata.cash -= item.price
						playerdata.inventory.insert( len(playerdata.inventory)-1, planetdata.shopitems[sel2] )
						if len(planetdata.shopitems) == 0:
							state = 'mainscreen'
						elif sel2 >= len(planetdata.shopitems):
							sel2 -= 1
					
		if selections[sel] == "Travel":
			fnt.Print(235,70,"Travel")
			i = 100
			for toplanet in planetdata.travelto:
				plainfnt.Print(235,i,data.info[toplanet].name)
				plainfnt.RightPrint(440,i,`data.info[toplanet].price`)
				i += 15
		if state == 'travelling':
			Video.DrawRect(234,98+sel2*15,440,114+sel2*15,RGB(255,255,255))
			if Input.up.Pressed():		sel2 -= 1
			if Input.down.Pressed():	sel2 += 1
			sel2 %= len(planetdata.travelto)
			if Input['ESCAPE'].Pressed():
				state = 'mainscreen'
			targetplanet = planetdata.travelto[sel2]
			if Input.enter.Pressed() and playerdata.cash >= data.info[targetplanet].price:
				playerdata.cash -= data.info[targetplanet].price
				playerdata.planet = targetplanet
				planetdata = data.info[ targetplanet ]
				state = 'mainscreen'
				exec( "title."+targetplanet+"()" )
				if len(planetdata.travelto)>0 and playerdata.cash >= data.info[planetdata.travelto[0]].price:
					enabled[4] = 1
				enabled[5] = 0
				availablemissions = data.missionsreevaluate( playerdata )

		if selections[sel] == "Save":
			if not enabled[sel]:
				plainfnt.Print(235,70,"Your game isn't saved!")
			else:
				plainfnt.Print(235,70,"Game saved!")
			plainfnt.Print(235,100,"Completed missions:")
			i = 120
			for item in playerdata.completedmissions:
				mdata = data.missions[item]
				plainfnt.Print(235,i,mdata.name)
				i += 15
				
		if state == 'quitconfirm':
			Video.DrawRect(180,200,460,300,RGB(0,0,0,200),1)
			Video.DrawRect(180,200,460,300,RGB(100,255,100))
			Video.DrawRect(295+sel2*30,238,322+sel2*30,253,RGB(255,255,255))
			if Input.right.Pressed():	sel2 = 1
			if Input.left.Pressed():	sel2 = 0
			plainfnt.CenterPrint( 320,220, "Do you really want to quit?" )
			plainfnt.CenterPrint( 320,240, "Yes\tNo" )
			if Input.enter.Pressed():
				if sel2 == 0:
					state = 'fadeout'
					sel2 = 50
				else:
					state = 'mainscreen'
			if Input['ESCAPE'].Pressed():
				state = 'mainscreen'
			
		if timer<50:
			Video.DrawRect(0,0,Video.xres,Video.yres,RGB(0,0,0,255-timer*255/50),1)
		if state == 'fadeout':
			Video.DrawRect(0,0,Video.xres,Video.yres,RGB(0,0,0,255-sel2*255/50),1)
		Video.ShowPage()