from ika import *
import data

def drawWassern( obj ):
	size = obj.lifecounter*10/obj.lifetime+5
	Video.DrawEllipse( int(obj.x), int(obj.y), int(size),int(size), RGB(150,150,255,int((obj.lifetime-obj.lifecounter)*255/(obj.lifetime+1))),1)

def drawExplosion( obj ):
	size = (obj.lifetime-obj.lifecounter)*obj.drawsize/obj.lifetime
	for i in range(1,5):
		Video.DrawEllipse( int(obj.x), int(obj.y), int(size-i*2),int(size-i*2), RGB(255,0,0,int((obj.lifetime-obj.lifecounter)*255/obj.lifetime)),1)

def drawMineral( obj ):
	Video.DrawEllipse( int(obj.x), int(obj.y), 6,6, RGB(150,150,255, int(Random(100,150))),1)
	rad = Random(15,20)
	Video.DrawEllipse( int(obj.x), int(obj.y), int(rad),int(rad), RGB(150,150,255))
	
def drawBullet( obj ):
	for i in range(6):
		Video.DrawEllipse( int(obj.x), int(obj.y), 10-i*2,10-i*2, RGB(255,i*50,255),1)

def drawFire( obj ):
	alpha = int((obj.lifetime-obj.lifecounter)*255/obj.lifetime)
	for i in range(6):
		Video.DrawEllipse( int(obj.x), int(obj.y), 15-i*3,15-i*3, RGB(255,i*50,0,alpha),1)
	
def drawScanning( obj ):
	thesprite = obj.created
	if thesprite.armor > 0:
		spriteinfo = data.info[thesprite.type]
		Video.DrawRect(int(thesprite.x-50),int(thesprite.y-50),int(thesprite.x+50),int(thesprite.y+50),RGB(150,255,150))
		if spriteinfo.armormax != 0:
			Video.DrawRect(int(thesprite.x-50),int(thesprite.y-60),int(thesprite.x-50+thesprite.armor*100/spriteinfo.armormax),int(thesprite.y-50),RGB(0,255,0),1)
			Video.DrawRect(int(thesprite.x-50),int(thesprite.y-60),int(thesprite.x-50+thesprite.armor*100/spriteinfo.armormax),int(thesprite.y-50),RGB(150,255,150))
			
def drawDracBody( obj ):
	Video.DrawEllipse( int(obj.x), int(obj.y), 20,20, RGB(0,150,0),1)
	Video.DrawEllipse( int(obj.x), int(obj.y), 20,20, RGB(0,0,0))