from ika import *
import movescripts
import classes
import data
import math

fnt = Font("./graphics/if.fnt")
plainfnt = Font("./graphics/plain.fnt")
missiontime = 9000
tempthing = None
def missiontimer( missionname, missiondata ):
	eval( missionname+"timer( missiondata )" )



########################################
######### Spawning functions ###########
########################################

def missionreport( missionname, missiondata ):
	timer = missiondata.timer - missiontime
	if timer < 300:
		fnt.CenterPrint(320,230,"Mission completed")
		if Input.enter.Pressed():
			missiondata.timer = missiontime+300
	else:
		eval( missionname+"report( missiondata )" )

def spawnMeteoroid( type, sprites, x=0, y = -30 ):
	if type < 4:
		if type%2 == 0:
			newx = Random(50,320)
		else:
			newx = Random(320,590)
		if type < 2:
			minimets = [ classes.Particle('mineral',ySpeed=Random(10,30)/10.0,moveScript=movescripts.moveConst,spawnondeath=classes.Explosion()) ]
		else:
			minimets = []
		for i in range(3):
			minimets.append(classes.Particle('minimeteoroid',xSpeed=Random(-10,11)/5.0,ySpeed=Random(-10,11)/5.0,moveScript=movescripts.moveConst,spawnondeath=classes.Explosion(drawsize=30,lifetime=20)))
		newmeteoroid = classes.Particle('meteoroid', x=newx, y=-100,ySpeed=1,spawnondeath=minimets)
		newmeteoroid.moveScript = movescripts.moveConst
		sprites.append( newmeteoroid )
	elif type == 4:
		newx = Random(10,630)
		minimet = classes.Particle('minimeteoroid',x=newx,y=-30,ySpeed=Random(5,15)/5.0,moveScript=movescripts.moveConst,spawnondeath=classes.Explosion(drawsize=30,lifetime=20))
		sprites.append( minimet )
	elif type == 5:
		if x == 0:
			newx = Random(50,590)
		else:
			newx = x
		minimet = classes.Particle('minimeteoroid',x=newx,y=y,yAcc=Random(5,15)/5.0,moveScript=movescripts.moveAccelerate,spawnondeath=classes.Explosion(drawsize=30,lifetime=20))
		sprites.append( minimet )

def spawnPirate( type, missiondata ):	
	sprites = missiondata.sprites
	timer = missiondata.timer
	if type == 0:
		newx = 800-Random(0,2)*900
		newpirate = classes.Particle('pirate', x=newx, y=Random(50,150),created=timer,spawnondeath=classes.Explosion())
		newpirate.moveScript = movescripts.moveBackForth
		newpirate.attackScript = movescripts.attackConst
		sprites.append( newpirate )
	if type == 1:
		newx = 800-Random(0,2)*900
		piece = classes.Particle('piratepiece',xSpeed=Random(-10,11)/5.0,ySpeed=Random(-10,11)/5.0,moveScript=movescripts.moveConst,spawnondeath=classes.Explosion(drawsize=30,lifetime=20))
		newpirate = classes.Particle('pirate', x=newx,y=Random(50,150),created=timer,spawnondeath=[classes.Explosion(),piece])
		newpirate.moveScript = movescripts.moveFacePlayer
		newpirate.attackScript = movescripts.attackConst
		sprites.append( newpirate )
	if type == 2:
		newpirate  = classes.Particle('pirate', x=-100, y=-100,xAcc= 0.1,yAcc=0.1,created=timer,spawnondeath=classes.Explosion())
		newpirate2 = classes.Particle('pirate', x= 740, y=-100,xAcc=-0.1,yAcc=0.1,created=timer,spawnondeath=classes.Explosion())
		newpirate.moveScript = movescripts.moveAccelerate
		newpirate2.moveScript = movescripts.moveAccelerate
		newpirate.attackScript = movescripts.attackConst
		newpirate2.attackScript = movescripts.attackConst
		sprites.append( newpirate )
		sprites.append( newpirate2 )

def spawnDracen( type, missiondata ):
	sprites = missiondata.sprites
	timer = missiondata.timer
	if type == 0:
		newx = 800-Random(0,2)*900
		newdracen = classes.Particle('dracen', x=newx, y=Random(50,280),created=timer,spawnondeath=classes.Explosion())
		newdracen.moveScript = movescripts.moveBackForth
		newdracen.attackScript = movescripts.attackConst
		sprites.append( newdracen )
	if type == 1:
		newx = Random(40,600)
		ondeath = classes.Explosion()
		if Random(0,50) == 0:
			ondeath = [ classes.Explosion(), classes.Particle('dracenpiece',xSpeed=Random(-10,11)/5.0,ySpeed=Random(-10,11)/5.0,moveScript=movescripts.moveConst,spawnondeath=classes.Explosion(drawsize=30,lifetime=20) ) ]
		newdracen = classes.Particle('dracen', x=newx, y=-30,ySpeed=1,yAcc=0.1,created=timer,spawnondeath=ondeath)
		newdracen.moveScript = movescripts.moveAccelerate
		newdracen.attackScript = movescripts.attackConst
		sprites.append( newdracen )
	if type == 2:
		ondeath = classes.Explosion()
		if Random(0,50) == 0:
			ondeath = [ classes.Explosion(), classes.Particle('dracenpiece',xSpeed=Random(-10,11)/5.0,ySpeed=Random(-10,11)/5.0,moveScript=movescripts.moveConst,spawnondeath=classes.Explosion(drawsize=30,lifetime=20) ) ]
		newdracen = classes.Particle('dracen', x=320, y=-30,ySpeed=1,yAcc=0.1,created=timer,spawnondeath=ondeath)
		newdracen.moveScript = movescripts.moveFacePlayer
		newdracen.attackScript = movescripts.attackConst
		sprites.append( newdracen )


def spawnTrader( type, missiondata ):
	sprites = missiondata.sprites
	timer = missiondata.timer
	if type == 0:
		newx = Random(40,600)
		newtrader = classes.Particle('trader2', x=newx, y=-30,ySpeed=1,yAcc=0.1,moveScript = movescripts.moveAccelerate, spawnondeath=classes.Explosion())
		sprites.append( newtrader )



########################################
########## Sidunia missions ############
########################################

def miningtimer( missiondata ):
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer < missiontime-500:
		if timer%70 == 0:
			if timer%140:
				spawnMeteoroid( 0, sprites )
			else:
				spawnMeteoroid( 1, sprites )
	if timer == missiontime:
		endgame( missiondata )

def miningreport( missiondata ):
	collected = missiondata.collected
	reportbox()
	skillsreput = (len(collected)-12)/4 + (missiondata.fpart.armor-500*missiondata.fighter.armorclass)/700
	cashgained = 100*len(collected)
	Printer( "Minerals collected: "+`len(collected)`,200,160 )
	Printer( "Cash gained: 100x"+`len(collected)`+" = "+`cashgained` )
	Printer( "Skills reputation gained: "+`skillsreput` )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashgained,0,skillsreput,None)
	
	
def pirateattacktimer( missiondata ):
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer < missiontime-500 and timer>1:
		if timer%400 == 0:
			spawnPirate( 0, missiondata )
		if timer%1000 == 0:
			spawnPirate( 1, missiondata )
		if timer%100 == 0:
			if timer%200:
				spawnMeteoroid( 2, sprites )
			else:
				spawnMeteoroid( 3, sprites )
		if timer%80 == 0:
			spawnMeteoroid( 4, sprites )
	if timer == missiontime:
		endgame( missiondata )

def pirateattackreport( missiondata ):
	d = missiondata.playerdestroyed
	reportbox()
	pdestroyed = d.count('pirate')
	reput = (pdestroyed-13)/5
	skillsreput = (pdestroyed-13)/5
	cashgained = 200*pdestroyed
	itemgained = None
	Printer( "Pirate ships destroyed: "+`pdestroyed`,200,160 )
	Printer( "Cash gained: 200x"+`pdestroyed`+" = "+`cashgained` )
	Printer( "Reputation gained: "+`reput` )
	Printer( "Skills reputation gained: "+`skillsreput` )
	if len(missiondata.collected):
		itemgained = 'pirazer'
		Printer( "Picked up Pirazer!" )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashgained,0,skillsreput,itemgained)

def chasepiratestimer( missiondata ):
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer < missiontime-500 and timer > 1:
		if timer%500 == 0:
			spawnPirate( 0, missiondata )
		if timer%1250 == 0:
			spawnPirate( 1, missiondata )
		if timer%100 == 0:
			if timer%200:
				spawnMeteoroid( 2, sprites )
			else:
				spawnMeteoroid( 3, sprites )
	if timer == missiontime:
		endgame( missiondata )

def chasepiratesreport( missiondata ):
	d = missiondata.playerdestroyed
	reportbox()
	pdestroyed = d.count('pirate')
	reput = (pdestroyed-12)/5
	skillsreput = (pdestroyed-12)/5
	cashgained = 200*pdestroyed
	itemgained = None
	Printer( "Pirate ships destroyed: "+`pdestroyed`,200,160 )
	Printer( "Cash gained: 200x"+`pdestroyed`+" = "+`cashgained` )
	Printer( "Reputation gained: "+`reput` )
	Printer( "Skills reputation gained: "+`skillsreput` )
	if len(missiondata.collected):
		itemgained = 'pirazer'
		Printer( "Picked up Pirazer!" )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashgained,0,skillsreput,itemgained)


def piratelairtimer( missiondata ):
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer < missiontime/2:
		if timer%1000 >= 900 and timer%30 == 0:
			spawnPirate( 2, missiondata )
		if timer%1000 == 400:
			spawnPirate( 0, missiondata )
		if timer%1000 == 500:
			spawnPirate( 1, missiondata )
	elif timer < missiontime*2/3:
		if timer%20 == 0:
			spawnMeteoroid( 5, sprites )
			spawnMeteoroid( 5, sprites )
	elif timer == missiontime*2/3:
		explosions = []
		for i in range(20):
			explosions.append( classes.Explosion(drawsize=Random(30,70),lifetime=Random(50,100)) )
		newpirate = classes.Particle('pirateboss', x=320, y=-100,created=timer,spawnondeath=explosions)
		sprites.insert( 1, newpirate )
	elif timer > missiontime*2/3:
		if len(sprites)>1 and sprites[1].type == 'pirateboss':
			thetime = timer - sprites[1].created
			if timer%1000 < 500:
				movescripts.moveBackForth( sprites[1], missiondata )
				if thetime%30 == 0:
					pdata = data.info[ sprites[1].type ]
					try:
						deg = math.atan( (sprites[0].y-sprites[1].y-pdata.h/2)*1.0/(sprites[0].x-sprites[1].x+133) )
						if sprites[0].y>sprites[1].y-pdata.h/2 and sprites[0].x<sprites[1].x-133:
							deg += math.pi
					except ZeroDivisionError:
						if sprites[0].y < sprites[1].y+pdata.h/2:
							deg = math.pi/2
						else:	deg = 0
					sprites.append( classes.Particle('bulletshot', sprites[1].x-133, sprites[1].y+pdata.h/2-10, 3.0*math.cos(deg),3.0*math.sin(deg)) )
					sprites[len(sprites)-1].moveScript = movescripts.moveConst
					try:
						deg = math.atan( (sprites[0].y-sprites[1].y-pdata.h/2)*1.0/(sprites[0].x-sprites[1].x-133) )
						if sprites[0].y>sprites[1].y-pdata.h/2 and sprites[0].x<sprites[1].x+133:
							deg += math.pi
					except ZeroDivisionError:
						if sprites[0].y < sprites[1].y+pdata.h/2:
							deg = math.pi/2
						else:	deg = 0
					sprites.append( classes.Particle('bulletshot', sprites[1].x+133, sprites[1].y+pdata.h/2-10, 3.0*math.cos(deg),3.0*math.sin(deg) ) )
					sprites[len(sprites)-1].moveScript = movescripts.moveConst
			else:
				if timer%20 == 0:
					spawnMeteoroid( 5, sprites, Random(int(sprites[1].x-180),int(sprites[1].x+180)), 180 )
					spawnMeteoroid( 5, sprites, Random(int(sprites[1].x-180),int(sprites[1].x+180)), 180 )
		if len(sprites)>2 and sprites[1].type != 'pirateboss' and missiondata.fpart.armor > 0:
			endgame( missiondata )

def piratelairreport( missiondata ):
	d = missiondata.playerdestroyed
	reportbox()
	pdestroyed = d.count('pirate')
	reput = (pdestroyed-8)/5
	skillsreput = (pdestroyed-8)/5
	cashgained = 200*pdestroyed+5000
	itemgained = None
	Printer( "Pirate ships destroyed: "+`pdestroyed`,200,160 )
	Printer( "Cash gained: 5000 + 200x"+`pdestroyed`+" = "+`cashgained` )
	Printer( "Reputation gained: "+`reput` )
	Printer( "Skills reputation gained: "+`skillsreput` )
	if len(missiondata.collected):
		itemgained = 'pirazer'
		Printer( "Picked up Pirazer!" )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashgained,0,skillsreput,itemgained)



def wateringtimer( missiondata ):
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer < missiontime/2-500:
		if timer%85 == 0:
			for j in range(2):
				explosions = []
				for i in range(3):
					explosions.append(classes.Explosion(drawsize=20,lifetime=20))
				wetfield = classes.Particle('fieldwatered',ySpeed=1,spawnondeath=explosions)
				wetfield.moveScript = movescripts.moveConst
				if j == 0:
					newx = Random(1,4)*81
				else: newx = Random(4,8)*81
				newfield = classes.Particle('fielddry', x=newx, y=-100,ySpeed=1,spawnondeath=explosions,spawnonfreeze=wetfield)
				newfield.moveScript = movescripts.moveConst
				sprites.append( newfield )
	if timer == missiontime/2:
		sprites.pop(0)
		missiondata.gamestate = 'missioncompleted'
		
def wateringreport( missiondata ):
	collected = missiondata.collected
	nd = missiondata.notdestroyed
	d = missiondata.playerdestroyed
	watered = nd.count('fieldwatered')
	destroyed = d.count('fielddry')+d.count('fieldwatered')
	cashplus = 100*watered
	cashminus = -500*(d.count('fielddry')+d.count('fieldwatered'))
	cashtotal = cashplus+cashminus
	skillsreput = (watered-20)/10 + (missiondata.fpart.armor-500*missiondata.fighter.armorclass)/700
	reportbox()
	Printer( "Fields watered: "+`watered`,200,160 )
	Printer( "Cash: 100x"+`watered`+" = "+`cashplus` )
	Printer( "Fields destroyed: "+`destroyed` )
	Printer( "Cash: -500x"+`destroyed`+" = "+`cashminus` )
	Printer( "Total cash gained: "+`cashtotal` )
	Printer( "Skills reputation gained: "+`skillsreput` )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashtotal,0,skillsreput,None)



########################################
########## Tardunia missions ###########
########################################


def terminationtimer( missiondata ):
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer < missiontime-500 and timer>1:
		if timer%600 == 0:
			spawnDracen( 0, missiondata )
		if timer%1000 > 900 and timer%30 == 0:
			spawnDracen( 1, missiondata )
	if timer == missiontime:
		endgame( missiondata )
		missiondata.gamestate = 'missioncompleted'
	
def terminationreport( missiondata ):
	destroyed = missiondata.playerdestroyed.count('dracen')
	reportbox()
	skillsreput = (destroyed-15)/5 + (missiondata.fpart.armor-500*missiondata.fighter.armorclass)/700
	cashgained = 150*destroyed
	itemgained = None
	Printer( "Dracens terminated: "+`destroyed`,200,160 )
	Printer( "Cash gained: 150x"+`destroyed`+" = "+`cashgained` )
	Printer( "Skills reputation gained: "+`skillsreput` )
	if len(missiondata.collected):
		itemgained = 'firecannon'
		Printer( "Picked up Firecannon!" )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashgained,0,skillsreput,itemgained)


def termination2timer( missiondata ):
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer < missiontime-500 and timer>1:
		if timer%200 == 0:
			spawnTrader( 0, missiondata )
		if timer%400 == 0:
			spawnDracen( 0, missiondata )
		if timer%1000 > 900 and timer%40 == 0:
			spawnDracen( 1, missiondata )
	if timer == missiontime:
		endgame( missiondata )
		missiondata.gamestate = 'missioncompleted'
	
def termination2report( missiondata ):
	ddracens = missiondata.playerdestroyed.count('dracen')
	dtraders = missiondata.playerdestroyed.count('trader2')
	etraders = missiondata.destroyed.count('trader2')
	reportbox()
	reput = 2 - dtraders
	skillsreput = (ddracens-10)/5 - dtraders/2 - etraders/4
	cashplus = 150*ddracens
	cashminus = -500*dtraders
	cashtotal = cashplus+cashminus
	itemgained = None
	Printer( "Dracens terminated: "+`ddracens`,200,160 )
	Printer( "Cash gained: 150x"+`ddracens`+" = "+`cashplus` )
	Printer( "Traders destroyed by you: "+`dtraders` )
	Printer( "Cash gained: -500x"+`dtraders`+" = "+`cashminus` )
	Printer( "Cash total: "+`cashtotal` )
	Printer( "Traders destroyed by Dracen: "+`etraders` )
	Printer( "Reputation gained: "+`reput` )
	Printer( "Skills reputation gained: "+`skillsreput` )
	if len(missiondata.collected):
		itemgained = 'firecannon'
		Printer( "Picked up Firecannon!" )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashtotal,reput,skillsreput,itemgained)


def termination3timer( missiondata ):
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer == 0:
		body = classes.Particle( 'drachead', x=320,y=100, moveScript=movescripts.moveWave,spawnondeath=classes.Explosion() )
		body.attackScript = movescripts.attackConst
		sprites.insert( 1, body )
		for i in range(9):
			body = classes.Particle( 'dracbody', x=320,y=100, moveScript=movescripts.followCreated, created = body,spawnondeath=classes.Explosion() )
			sprites.insert( 1, body )
	elif timer < missiontime-1000:
		if timer%300 == 0:
			spawnDracen( 1, missiondata )
		if timer%500 == 0:
			spawnDracen( 0, missiondata )
		if timer%700 == 0:
			spawnDracen( 2, missiondata )
	elif timer < missiontime:
		for sprite in sprites[1:]:
			if sprite.type != 'explosion' and not data.info[sprite.type].projectile:
				sprite.moveScript = moveConst
	else:
		endgame( missiondata )
		missiondata.gamestate = 'missioncompleted'
			
	
def termination3report( missiondata ):
	dleader = missiondata.playerdestroyed.count('drachead')
	destroyed = missiondata.playerdestroyed.count('dracen')
	reportbox()
	skillsreput = dleader + (destroyed-15)/5 + (missiondata.fpart.armor-500*missiondata.fighter.armorclass)/700
	cashgained = 100*destroyed + 5000*dleader
	itemgained = None
	Printer( "Leader terminated: "+["Yes","No"][dleader],200,160 )
	Printer( "Dracens terminated: "+`destroyed`,200,160 )
	Printer( "Cash gained: 5000x"+dleader+" + 100x"+`destroyed`+" = "+`cashgained` )
	Printer( "Skills reputation gained: "+`skillsreput` )
	if len(missiondata.collected):
		itemgained = 'firecannon'
		Printer( "Picked up Firecannon!" )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashgained,1,skillsreput,itemgained)



def protectiontimer( missiondata ):
	global tempthing
	timer = missiondata.timer
	sprites = missiondata.sprites
	if timer == 50:
		tradersprite = classes.Particle( 'trader', x=320,y=600,moveScript=movescripts.moveBehindPlayer,spawnondeath=classes.Explosion() )
		sprites.insert( 1, tradersprite )
	if 50 < timer < missiontime-500 and missiondata.gamestate == 'normal':
		if timer%800 == 0:
			spawnDracen( 0, missiondata )
		if timer%1500 < 50 and timer%20 == 0:
			spawnDracen( 1, missiondata )
		if timer > missiontime/2:
			if timer%1000 == 0:
				spawnPirate( 0, missiondata )
				spawnPirate( 1, missiondata )
		if sprites[1].type != 'trader':
			sprites.pop(0)
			missiondata.gamestate = 'missionfailed'
			missiondata.statchanges = (1,0,-1,-3,None)
	if timer == missiontime:
		sprites = missiondata.sprites
		sprites.pop(0)
		for sprite in sprites[1:]:
			sprite.removeself( missiondata )
		sprites[0].yAcc = -1
		sprites[0].moveScript = movescripts.moveAccelerate
		tempthing = sprites[0]
		missiondata.gamestate = 'missioncompleted'

def protectionreport( missiondata ):
	reportbox()
	skillsreput = (tempthing.armor-350)/75
	cashgained = 5000
	itemgained = None
	Printer( "Cash gained: "+`cashgained`,200,160 )
	Printer( "Skills reputation gained: "+`skillsreput` )
	if missiondata.collected[0] == 'dracenpiece':
		itemgained = 'firecannon'
		Printer( "Picked up Firecannon!" )
	elif missiondata.collected[0] == 'piratepiece':
		itemgained = 'pirazer'
		Printer( "Picked up Pirazer!" )
	Printer( "" )
	Printer( "Press enter to continue..." )
	missiondata.statchanges = (1,cashgained,0,skillsreput,itemgained)


########################################
########### Misc functions #############
########################################

def endgame( missiondata ):
	sprites = missiondata.sprites
	sprites.pop(0)
	for sprite in sprites:
		sprite.lasthit = classes.ENEMY
		sprite.removeself( missiondata )
	for sprite in sprites:
		if sprite.type != 'explosion':
			sprites.remove( sprite )
	missiondata.gamestate = 'missioncompleted'

def reportbox():
	Video.DrawRect(180,100,460,400,RGB(100,100,100,100),1)
	Video.DrawRect(180,100,460,400,RGB(0,255,0))
	fnt.CenterPrint(320,120,"Mission report")
	
printerx, printery = 0,0
def Printer( text, px = None, py = None):
	global printerx, printery
	if px == None:
		px, py = printerx, printery
	plainfnt.Print( px, py, text )
	py += plainfnt.height+3
	printerx, printery = px, py