from ika import *
from math import cos,sin
import classes
import game

fnt = Font("./graphics/if.fnt")
plainfnt = Font("./graphics/plain.fnt")

mmsong = Sound("club_bigboot.it")
mmsong.loop = 1

def groupname():
	pretimer = GetTime()
	timer = 0
	grouppic = Image("./graphics/group.png")
	while timer < 500:
		while pretimer < GetTime():
			Input.Update()
			pretimer += 1
			timer += 1
		Video.DrawRect(0,0,Video.xres,Video.yres,RGB(0,0,0),1)
		alpha = 255
		if timer < 100:
			alpha = timer*240/100
		if timer > 400:
			alpha = (500-timer)*240/100
		Video.TintBlit(grouppic,41,170,RGB(255,255,255,alpha))
		Video.ShowPage()
	Input['ESCAPE'].Pressed()

def show():
	title = Image( "./graphics/if.png" )
	componus = Image( "./graphics/componus.png" )
	fp = open( "./saves/savefiles.dat" )
	savedgames = fp.readlines()
	fp.close()
	sel = 0
	sel2 = 0
	state = 'selection'
	name = ""
	done = 0
	Input['LSHIFT'].Pressed()
	Input['RSHIFT'].Pressed()
	pretimer = GetTime()
	timer = 0
	while not done:
		while pretimer < GetTime():
			if timer == 0:
				mmsong.Play()
				fp = open( "./saves/savefiles.dat" )
				savedgames = fp.readlines()
				fp.close()
			Input.Update()
			pretimer += 1
			timer += 1
		Video.DrawRect(0,0,Video.xres, Video.yres, RGB(0,0,0),1)
		if timer >= 400:
			Video.DrawRect(100,10,514,73, RGB(255,255,255),1)
			title.Blit(100,10)
			componus.Blit( 300,80 )
			
			if state == 'selection':
				if Input['ESCAPE'].Pressed():
					done = 1
				if Input.down.Pressed():
					sel += 1
				if Input.up.Pressed():
					sel -= 1
				if Input.enter.Pressed():
					if sel == 0:
						state = 'name input'
					if sel == 1 and len(savedgames)>0:
						state = 'loadgame'
					if sel == 2:
						done = 1
				x,y = int(cos(timer/50.0)*10), int(sin(timer/50.0)*16)
				if x<0:
					y = -y
					x = -x
				sel %= 3
				color = RGB(200,220,255)
				Video.DrawLine( 220+x, 312+y+sel*50, 420-x, 312+y+sel*50, color)
				Video.DrawLine( 220+x, 312+y+sel*50, 220-x, 312-y+sel*50, color)
				Video.DrawLine( 420-x, 312+y+sel*50, 420+x, 312-y+sel*50, color)
				fnt.CenterPrint( Video.xres/2,300, "Start game" )
				fnt.CenterPrint( Video.xres/2,350, "Load game" )
				fnt.CenterPrint( Video.xres/2,400, "Exit" )
				Video.DrawLine( 220-x, 312-y+sel*50, 420+x, 312-y+sel*50, color)
				
			elif state == 'name input':
				nextletter = Input.GetKey()
				if Input['ESCAPE'].Pressed():
					name = ""
					state = 'selection'
				if Input['BACKSPACE'].Pressed():
					name = name[:-1]
				if nextletter != None and len(name)<10:
					if not (Input['LSHIFT'].Position() or Input['RSHIFT'].Position()):
						name += nextletter
					else:
						name += nextletter.upper()
				fnt.CenterPrint( Video.xres/2,300, "Write your name:" )
				fnt.CenterPrint( Video.xres/2,350, name+"_" )
				if Input.enter.Pressed() and name != "":
					intro()
					mmsong.Pause()
					game.newgame(name)
					state = 'selection'
					name = ""
					pretimer = GetTime()
					timer = 0
			elif state == 'loadgame':
				fnt.CenterPrint( Video.xres/2,250, "Saved games" )
				i = 300
				for line in savedgames:
					plainfnt.CenterPrint(320,i,line)
					i += 20
				Video.DrawRect(260,298+sel2*20,380,315+sel2*20,RGB(255,255,255))
				if Input.up.Pressed():
					sel2 -= 1
				if Input.down.Pressed():
					sel2 += 1
				if Input['ESCAPE'].Pressed():
					state = 'selection'
				if Input.enter.Pressed():
					mmsong.Pause()
					game.loadgame(savedgames[sel2].strip())
					state = 'selection'
					pretimer = GetTime()
					timer = 0
					Video.DrawRect(0,0,Video.xres,Video.yres,RGB(0,0,0),1)
				sel2 %= len(savedgames)
		else:
			if timer < 100:
				pass
			elif timer*2-200<415:
				Video.DrawRect(100,10,-100+timer*2,73, RGB(255,255,255),1)
			else:
				Video.DrawRect(100,10,514,73, RGB(255,255,255),1)
				componus.Blit( 300,80 )
				if timer<357:
					Video.DrawRect(300,80,468,108,RGB(0,0,0,250-(timer-308)*5),1)
			if Input.enter.Pressed():
				timer = 400
			title.Blit(100,10)
		Video.ShowPage()

	Exit("")
	
	
def showtext( textlist,planetname, planetpic ):
	timer = 0
	div = 4
	pretimer = GetTime()
	sfield = classes.StarField()
	while not Input.enter.Pressed() and timer<50*len(textlist)*div:
		while pretimer < GetTime():
			Input.Update()
			pretimer += 1
			timer += 1
			if Input.up.Position():
				timer -= 3
			if Input.down.Position():
				timer += 3
			sfield.move(0,0.1)
		Video.DrawRect(0,0,Video.xres, Video.yres, RGB(0,0,0),1)
		sfield.draw()
		i = 0
		for textline in textlist:
			fnt.Print(20, Video.yres-timer/div+fnt.height*i, textline)
			i += 1
		
		for i in range(25):
			Video.DrawLine(0,i,Video.xres,i,RGB(0,0,0,255-i*10))
			Video.DrawLine(0,Video.yres-i,Video.xres,Video.yres-i,RGB(0,0,0,255-i*10))

		Video.ShowPage()
		
	timer = 0
	pname = Image( "./graphics/"+planetname+".png" )
	ppic = Image("./graphics/"+planetpic+".png")
	while timer<950:
		while pretimer < GetTime():
			Input.Update()
			pretimer += 1
			timer += 1
			sfield.move(0,0.1)
		if Input.enter.Pressed() and timer<600:
			timer = 600
		Video.DrawRect(0,0,Video.xres, Video.yres, RGB(0,0,0),1)
		sfield.draw()
		if timer<350:
			ppic.Blit(800-timer*2,100)
		else:
			ppic.Blit(100,100)
			if timer<605:
				Video.TintBlit( pname, 80,60, RGB(timer-350,timer-350,timer-350,255) )
			else:
				pname.Blit(80,60)
			if timer>700:
				Video.DrawRect(0,0,Video.xres,Video.yres,RGB(0,0,0,timer-700),1)
		Video.ShowPage()
		
		
def intro():
	story = [
		"Somehow, I just can't be",
		"comfortable with this planet.",
		"The technology here is mostly",
		"outdated, and the planet itself",
		"is sparsely populated.",
		"",
		"I miss the crowds. Which is an",
		"irony, since I got my job to get",
		"away from people.",
		"",
		"My former job, that is.",
		"",
		"An accident during my previous",
		"mission in the Planet Cleaners",
		"Corporation cost me my job,",
		"most of my cash and left me",
		"stranded on this faraway planet,",
		"without enough cash to get to",
		"the nearest high populated",
		"solar system.",
		"",
		"But, I've finally gotten my",
		"fighter repaired.",
		"So now I'm a freelancer,",
		"stuck on this planet, taking",
		"stray jobs from anyone willing",
		"to hire me.",
	]
	showtext( story, 'sidunia','planet1' )

def tardunia():
	story = [
		"The trading planet Tardunia is",
		"the closest inhabitated planet",
		"to Sidunia, and the trading",
		"point for a bunch of faraway",
		"planets in the same cluster.",
		"",
		"Because of all the traders who",
		"come here for the minerals, this",
		"planet has slightly more",
		"advanced tech than Sidunia.",
		"",
		"During the trip with the inter-",
		"planetary cruiser, we defended",
		"against a few pirates. Apparently",
		"there are more of them.",
		"",
		"I guess I'll have to be careful."
	]
	showtext( story, 'tardunia','planet2' )
	
def merion():
	story = [
		"I'm getting closer to the bigger",
		"clusters now. Merion is one of",
		"the richer planets in the current",
		"cluster of planets.",
		"",
		"But I'm still far away from home.",
		"",
		"Unfortunately, it seems that it",
		"has come to an end for now. Time",
		"is running out, and my story will",
		"will have to stop here.",
		"",
		"So untill next time... I'll be",
		"waiting on Merion."
	]
	showtext( story, 'merion','planet3' )