from ika import *
import classes
import data
import flight
import movescripts
import math

def use( item, missiondata ):
	eval( item+"(missiondata)" )

def Blaster( missiondata ):
	sprites = missiondata.sprites
	sprites.append( classes.Particle('blastershot', missiondata.fpart.x, missiondata.fpart.y-missiondata.fighter.h/2, 0, -5,moveScript = movescripts.moveConst) )

def Blaster2( missiondata ):
	sprites = missiondata.sprites
	sprites.append( classes.Particle('blastershot', missiondata.fpart.x-9, missiondata.fpart.y-missiondata.fighter.h/2, 0, -5,moveScript = movescripts.moveConst) )
	sprites.append( classes.Particle('blastershot', missiondata.fpart.x+9, missiondata.fpart.y-missiondata.fighter.h/2, 0, -5,moveScript = movescripts.moveConst) )

def Rockets( missiondata ):
	sprites = missiondata.sprites
	obj = sprites[0]
	fighter = data.info[ obj.type ]
	sprites.append( classes.Particle('rocketshot', obj.x, obj.y-10, 0, 0, yAcc=-0.1, spawnondeath=classes.Explosion(70,dmggiven=100,lifetime=50)) )
	sprites[len(sprites)-1].moveScript = movescripts.moveAccelerate

def Wassern( missiondata ):
	sprites = missiondata.sprites
	obj = sprites[0]
	fighter = data.info[ obj.type ]
	sprites.append( classes.Particle('wasserndrop', obj.x, obj.y-fighter.h/2, Random(-1,2)/10.0, -3, yAcc=0.05,lifetime=70) )
	sprites[len(sprites)-1].moveScript = movescripts.moveAccelerate

def Pirazer( missiondata ):
	sprites = missiondata.sprites
	obj = sprites[0]
	fighter = data.info[ obj.type ]
	sprites.append( classes.Particle('pirazershotplayer', obj.x, obj.y-fighter.h/2, ySpeed=-10) )
	sprites[len(sprites)-1].moveScript = movescripts.moveConst

def Firecannon( missiondata ):
	sprites = missiondata.sprites
	fpart = missiondata.fpart
	fighter = missiondata.fighter
	sprites.append( classes.Particle('fireballplayer', fpart.x, fpart.y-fighter.h/2, xSpeed=Random(-10,11)/10.0, ySpeed=-5,xAcc = Random(-5,6)/50.0, yAcc=0.01, lifetime=70) )
	sprites[len(sprites)-1].moveScript = movescripts.moveAccelerate

def Collector( md ):
	for sprite in md.sprites:
		if data.info[sprite.type].size == classes.COLLECTABLE and md.fpart.y-sprite.y<250 and sprite.y<md.fpart.y:
			if sprite.x > md.fpart.x-md.fighter.w and sprite.x < md.fpart.x+md.fighter.w:
				sprite.push( (sprite.x-md.fpart.x)/-20.0,1)
				if md.fpart.y-sprite.y<50:
					md.collected.append( sprite.type )
					md.sprites.remove( sprite )

def Scanner( missiondata ):
	sprites = missiondata.sprites
	fpart = missiondata.fpart
	closest = None
	distance = 9999
	for sprite in sprites[1:]:
		if not data.info[sprite.type].projectile and sprite.type != 'explosion' and sprite.armor > 0:
			dist = math.hypot( sprite.x-fpart.x, sprite.y-fpart.y )
			if dist < distance:
				distance = dist
				closest = sprite
	if closest != None:
		sprites.append( classes.Particle( 'scanning', created=closest,lifetime=200 ) )
	

def addShield( missiondata, addition ):
	sprites = missiondata.sprites
	fighter = data.info['fighter']
	if sprites[0].shield < 1000*fighter.shieldclass:
		sprites[0].shield += addition

def Shields1( missiondata ):
	addShield( missiondata, 1 )

def Shields2( missiondata ):
	addShield( missiondata, 2 )
	
def Shields3( missiondata ):
	addShield( missiondata, 3 )

def Shields4( missiondata ):
	addShield( missiondata, 3 )
	
def Empty( missiondata ):
	pass


# enemy attacks
def enpirazer(particle,missiondata):
	thetime = missiondata.timer-particle.created
	if thetime%15 == 0:
		sprites = missiondata.sprites
		pdata = data.info[ particle.type ]
		sprites.append( classes.Particle('pirazershot', particle.x, particle.y+pdata.h/2, 0,10) )
		sprites[len(sprites)-1].moveScript = movescripts.moveConst

def enfireball( particle, missiondata ):
	thetime = missiondata.timer-particle.created
	if thetime%30 == 0:
		sprites = missiondata.sprites
		pdata = data.info[ particle.type ]
		sprites.append( classes.Particle('fireball', particle.x, particle.y+pdata.h/2, xSpeed=Random(-10,11)/10.0, ySpeed=5,xAcc = Random(-5,6)/50.0, yAcc=-0.01, lifetime=70) )
		sprites[len(sprites)-1].moveScript = movescripts.moveAccelerate
